@ECHO OFF
rem  This script cleans IDA's map file of all unknowns,nullsubs,...
rem  and loads cleaned map into SIce.
rem
rem  NOW you can use more than one attribute at the same time
rem  (but not more than 8, if you count user_string as attributte too).
rem  You should put REM infront of the line 155, if you don't want that
rem  your map file is deleted.
rem
rem  CAUTION! You must include paths to SoftIce and SoftIce\Util16
rem  into autoexec.bat .
rem  And if you wish you can put this files into SoftIce\Util16 directory.
rem  
rem  USE:  make [mapname] [attributes] [user string]
rem
rem        mapname is without the extensions (just the name)
rem        user string = begining of the string to clean
rem                      (it must be after the U or AU attribute)
rem
rem  attributes: (cleans your map file of : )
rem    A        is  D & L & LR & O & S & UK  (all)
rem    AU       is  A & U (all + user defined)
rem    D        of all 'dword_...','word_...','byte_...' addresses
rem    L        of all 'loc_...' addresses
rem    LR       of all 'locret_...' addresses
rem    O        of all 'off_...' addresses
rem    S        of all 'sub_...' addresses
rem    U        all USER defined string addresses
rem             (user string must follow the U attribute)
rem             (...D U user_string S...)
rem    UK       of all 'unknown_libname_...','unk_...' addresses
rem
rem    H        this help
rem
rem  Attributes can be in lower case too.
rem              
rem  IF you forget the attribute or you write unknown one
rem  the script will assume your choice is A.
rem  IF everything is all right the DOS window will close when finished.
rem
rem  If something is missing or you are not pleased you can write to
rem  mostekaccess@mailcity.com
rem
rem
rem  P.S. If something is bothering you, try to do it your self and if it doesn't work
rem       than you know why I didn't make it so. :)


IF "%1"=="" GOTO HELP
IF "%1"=="h" GOTO HELP
IF "%1"=="H" GOTO HELP
IF "%1"=="?" GOTO HELP
IF "%1"=="/?" GOTO HELP
IF EXIST m2s.err DEL m2s.err
IF NOT EXIST %1.map GOTO ERRORF

IF EXIST in.m2s GOTO SECOND
ECHO GOING TO COMMAND.COM
REM >in.m2s
ECHO Atributi: %1 %2 %3 %4 %5 %6 %7 %8 %9
command.com /e:1024 /k call map2sice.bat %1 %2 %3 %4 %5 %6 %7 %8 %9
IF EXIST m2s.err GOTO ENDF
EXIT
GOTO ENDF

:SECOND
REM ******************************************************
REM ******************************************************
REM We are in second command process.
DEl in.m2s
copy %1.map }1{.map
SET USERFILE=%1
SHIFT
REM *******************************************************
:PROCESS
REM >}2{.map
IF "%1"=="" GOTO A
IF "%1"=="a" GOTO A
IF "%1"=="A" GOTO A
IF "%1"=="au" GOTO UA
IF "%1"=="AU" GOTO UA
IF "%1"=="d" GOTO D
IF "%1"=="D" GOTO D
IF "%1"=="l" GOTO L
IF "%1"=="L" GOTO L
IF "%1"=="lr" GOTO LR
IF "%1"=="LR" GOTO LR
IF "%1"=="o" GOTO O
IF "%1"=="O" GOTO O
IF "%1"=="s" GOTO S
IF "%1"=="S" GOTO S
IF "%1"=="u" GOTO UA
IF "%1"=="U" GOTO UA
IF "%1"=="uk" GOTO UK
IF "%1"=="UK" GOTO UK

:A
FIND /V "dword_" }1{.map | FIND /V "word_" | FIND /V "byte_" | FIND /V "loc_" | FIND /V "locret_" | FIND /V "off_" | FIND /V "sub_" |FIND /V "unknown_lib" | FIND /V "unk_" | FIND /V "----" >> }2{.map
GOTO ENDPROC

:D
FIND /V "dword_" }1{.map | FIND /V "word_" | FIND /V "byte_" | FIND /V "----" >> }2{.map
GOTO ENDPROC

:L
FIND /V "loc_" }1{.map | FIND /V "----" >> }2{.map
GOTO ENDPROC

:LR
FIND /V "locret_" }1{.map | FIND /V "----" >> }2{.map
GOTO ENDPROC

:O
FIND /V "off_" }1{.map | FIND /V "----" >> }2{.map
GOTO ENDPROC

:S
FIND /V "sub_" }1{.map | FIND /V "----" >> }2{.map
GOTO ENDPROC

:UK
FIND /V "unknown_lib" }1{.map | FIND /V "unk_" | FIND /V "----" >> }2{.map
GOTO ENDPROC

:UA
IF "%2"=="" GOTO ERRORS
IF "%1"=="U" GOTO U
IF "%1"=="u" GOTO U
FIND /V "dword_" }1{.map | FIND /V "word_" | FIND /V "byte_" | FIND /V "loc_" | FIND /V "locret_" | FIND /V "off_" | FIND /V "sub_" |FIND /V "unknown_lib" | FIND /V "unk_" | FIND /V "%2" | FIND /V "----" >> }2{.map
GOTO ENDPROC
:U
FIND /V "%2" }1{.map | FIND /V "----" >> }2{.map

:ENDPROC
SHIFT
IF "%0"=="U" GOTO USERSET
IF "%0"=="u" GOTO USERSET
IF "%0"=="AU" GOTO USERSET
IF "%0"=="au" GOTO USERSET
GOTO MOREATT
:USERSET
SHIFT

:MOREATT
DEL }1{.map
RENAME }2{.map }1{.map
IF NOT "%1"=="" GOTO PROCESS
REM ******************************************************
REM End of processing map file.
 
DEL %USERFILE%.map
RENAME }1{.map %USERFILE%.map
msym.exe %USERFILE%.map
nmsym.exe %USERFILE%.sym
nmsym.exe /SYM:%USERFILE%.nms
REM DEL %USERFILE%.map
DEL %USERFILE%.sym
DEL %USERFILE%.nms
GOTO ENDS

:ERRORS
DEL }1{.map
DEL }2{.map
REM >m2s.err
CLS
ECHO.
ECHO  Hmm, yep.    Error!
ECHO.
ECHO  You forgot to type the "userstring".
ECHO.
:ENDS
EXIT
REM End of second command process.
REM ******************************************************
REM ******************************************************

:HELP
CLS
ECHO  This script cleans IDA's map file of all unknowns,nullsubs,...
ECHO  and loads cleaned map into SIce.
ECHO  NOW you can use more than one attribute at the same time
ECHO  (but not more than 8, if you count user_string as attributte too).
ECHO.
ECHO  CAUTION! You must include paths to SoftIce and SoftIce\Util16
ECHO  into autoexec.bat .
ECHO  And if you wish you can put this files into SoftIce\Util16 directory.
ECHO.
ECHO  USE:  make [mapname] [attributes] [user string]
ECHO.
ECHO        mapname is without the extensions (just the name)
ECHO        user string = begining of the string to clean
ECHO                      (it must be after the U or AU attribute)
ECHO.
ECHO  attributes: (cleans your map file of : )
ECHO    A        is  D & L & LR & O & S & UK  (all)
ECHO    AU       is  A & U (all + user defined)
ECHO    D        of all 'dword_...','word_...','byte_...' addresses
ECHO    L        of all 'loc_...' addresses
ECHO    LR       of all 'locret_...' addresses
ECHO    O        of all 'off_...' addresses
ECHO    S        of all 'sub_...' addresses
ECHO    U        all USER defined string addresses
ECHO    UK       of all 'unknown_libname_...','unk_...' addresses
ECHO    H        this help
ECHO.
ECHO  Attributes can be in lower case too.
ECHO  IF you forget the attribute or you write unknown one
ECHO  the script will assume your choice is A.
ECHO  IF everything is all right the DOS window will close when finished.
ECHO.
ECHO  If something is missing or you are not pleased you can write to
ECHO  mostekaccess@mailcity.com
ECHO.
ECHO.
GOTO ENDF

:ERRORF
CLS
ECHO.
ECHO  Hmm, yep.    Error!
ECHO.
ECHO  You misspelled the map name.
ECHO.
:ENDF



